# This workflow uses actions that are not certified by GitHub.  They are
# provided by a third-party and are governed by separate terms of service,
# privacy policy, and support documentation.
#
# This workflow will install a prebuilt Ruby version, install dependencies, and
# run tests and linters.

name: "Ruby on Rails CI"
on:
  push:
    branches: [main]
  pull_request:
    branches: [main]
permissions:
  contents: read
jobs:
  build_and_test:
    runs-on: ubuntu-latest
    services:
      postgres:
        image: postgres:11-alpine
        ports:
          - "5432:5432"
        env:
          POSTGRES_DB: rails_test
          POSTGRES_USER: rails
          POSTGRES_PASSWORD: password
    env:
      RAILS_ENV: test
      DATABASE_URL: "postgres://rails:password@localhost:5432/rails_test"
    steps:
      - name: Checkout code
        uses: actions/checkout@v3
      # Add or replace dependency steps here
      - name: Install Chrome for integration/e2e tests
        uses: nanasess/setup-chromedriver@v2.0.0
      # The ruby version is taken from the .ruby-version file, no need to specify here.
      - name: Install Ruby and gems
        uses: ruby/setup-ruby@d2b39ad0b52eca07d23f3aa14fdf2a3fcc1f411c
        with:
          bundler-cache: true
      - name: Install frontend dependencies
        run: npm ci
      - name: Run Frontend build
        run: bin/vite build
      # Add or replace database setup steps here
      - name: Create db
        run: bin/rails db:migrate
      - name: Set up database schema
        run: bin/rails db:schema:load
      # Add or replace test runners here
      - name: Run tests
        run: bundle exec rspec
      # Add or replace any other lints here
      - name: Security audit dependencies
        run: bundler exec bundle audit check
      - name: Security audit application code
        run: bundler exec brakeman -q -w2
      - name: Lint Ruby files
        run: bundler exec rubocop --parallel
      - name: Lint Javascript and Sass files
        run: npm run lint
